<?php

/**
 * This is the model class for table "album".
 *
 * The followings are the available columns in table 'album':
 * @property integer $id
 * @property string $title
 * @property string $slug
 * @property integer $create_datetime
 * @property integer $update_datetime
 * @property string $image
 * @property integer $status
 *
 * The followings are the available model relations:
 * @property Category[] $categories
 * @property AlbumImage[] $albumImages
 */
class Album extends CActiveRecord {

    /**
     * @return string the associated database table name
     */
    public function tableName() {
        return 'album';
    }
    

    public function beforeValidate() {
        if ($this->isNewRecord) {
            // set the create date, last updated date and the user doing the creating  
            $this->create_datetime = time();
            $this->update_datetime = time();
        } else {
            //not a new record, so just set the last updated time and last updated user id     
            $this->update_datetime = time();
        }
        return parent::beforeValidate();
    }

    protected function beforeSave() {
        if (strlen($this->slug) == 0) {
            $this->slug = Common::sanitize($this->title);
        }
        return parent::beforeSave();
    }

    /**
     * @return array validation rules for model attributes.
     */
    public function rules() {
        // NOTE: you should only define rules for those attributes that
        // will receive user inputs.
        return array(
            array('title, create_datetime, update_datetime, status', 'required'),
            array('create_datetime, update_datetime, status', 'numerical', 'integerOnly' => true),
            array('title', 'length', 'max' => 200),
            array('slug', 'length', 'max' => 100),
            array('image', 'file', 'types' => 'jpg,jpeg,png,gif', 'maxSize' => 1024 * 1024 * 15 /* 15MB */, 'allowEmpty' => true),
            array('slug,categories', 'safe'),
            // The following rule is used by search().
            // @todo Please remove those attributes that should not be searched.
            array('id, title, slug, create_datetime, update_datetime, image, status', 'safe', 'on' => 'search'),
        );
    }

    /**
     * @return array relational rules.
     */
    public function relations() {
        // NOTE: you may need to adjust the relation name and the related
        // class name for the relations automatically generated below.
        return array(
            'categories' => array(self::MANY_MANY, 'Category', 'album_has_category(album_id, category_id)'),
            'albumImages' => array(self::HAS_MANY, 'AlbumImage', 'album_id'),
            'albumImagesCount' => array(self::STAT, 'AlbumImage', 'album_id'),
        );
    }

    /**
     * @return array customized attribute labels (name=>label)
     */
    public function attributeLabels() {
        return array(
            'id' => Yii::t('admin', 'ID'),
            'title' => Yii::t('admin', 'Title'),
            'slug' => Yii::t('admin', 'Slug'),
            'create_datetime' => Yii::t('admin', 'Create Datetime'),
            'update_datetime' => Yii::t('admin', 'Update Datetime'),
            'image' => Yii::t('admin', 'Conver Image'),
            'categories' => Yii::t('admin', 'Categories'),
            'status' => Yii::t('admin', 'Status'),
        );
    }

    /**
     * Retrieves a list of models based on the current search/filter conditions.
     *
     * Typical usecase:
     * - Initialize the model fields with values from filter form.
     * - Execute this method to get CActiveDataProvider instance which will filter
     * models according to data in model fields.
     * - Pass data provider to CGridView, CListView or any similar widget.
     *
     * @return CActiveDataProvider the data provider that can return the models
     * based on the search/filter conditions.
     */
    public function search() {
        // @todo Please modify the following code to remove attributes that should not be searched.

        $criteria = new CDbCriteria;

        if ($this->categories) {
            $criteria->together = true;
            $criteria->with = array('categories');
            $criteria->addInCondition('categories.id', array($this->categories));
        }

        $criteria->compare('id', $this->id);
        $criteria->compare('title', $this->title, true);
        $criteria->compare('slug', $this->slug, true);
        $criteria->compare('create_datetime', $this->create_datetime);
        $criteria->compare('update_datetime', $this->update_datetime);
        $criteria->compare('image', $this->image, true);
        $criteria->compare('status', $this->status);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

    /**
     * Returns the static model of the specified AR class.
     * Please note that you should have this exact method in all your CActiveRecord descendants!
     * @param string $className active record class name.
     * @return Album the static model class
     */
    public static function model($className = __CLASS__) {
        return parent::model($className);
    }

    public function behaviors() {
        return array(
            'FStatusBehavior' => array('class' => 'FStatusBehavior'),
            'activerecord-relation' => array(
                'class' => 'EActiveRecordRelationBehavior',
            )
        );
    }

    public function scopes() {
        return array(
            'published' => array(
                'condition' => 'status=1',
            ),
        );
    }

    public function getCategories() {
        $categories = array();
        foreach ($this->categories as $category) {
            $categories[] = $category->title;
        }
        return implode(" , ", $categories);
    }

}
